]>
git.madduck.net Git - code/vcsh.git/blobdiff - vcsh
madduck's git repository
Every one of the projects in this repository is available at the canonical
URL git://git.madduck.net/madduck/pub/<projectpath> — see
each project's metadata for the exact URL.
All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@ git. madduck. net .
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
SSH access, as well as push access can be individually
arranged .
If you use my repositories frequently, consider adding the following
snippet to ~/.gitconfig and using the third clone URL listed for each
project:
[url "git://git.madduck.net/madduck/"]
insteadOf = madduck:
-[ "$VCSH_DEBUG" = '1' ] && set -x
+[ -n "$VCSH_DEBUG" ] && set -x
SELF=$(basename $0)
[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
SELF=$(basename $0)
[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
+[ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+for check_directory in "$VCSH_BASE"
do
if [ ! -d "$check_directory" ]; then
if [ -e "$check_directory" ]; then
echo "$SELF: error: $check_directory exists but is not a directory" >&2
exit 2
else
do
if [ ! -d "$check_directory" ]; then
if [ -e "$check_directory" ]; then
echo "$SELF: error: $check_directory exists but is not a directory" >&2
exit 2
else
- mkdir $check_directory || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
+ mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
-VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
- [ "$VCSH_DEBUG" = '1' ] && echo "$SELF: debug: $1"
+ [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
- if [ "$VCSH_DEBUG" = '1' ] || [ "$VCSH_VERBOSE" = '1' ]; then echo "$SELF: verbose: $1"; fi
+ if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
}
# use <repo> Use this repository
}
# use <repo> Use this repository
+#
+# exit Exit vcsh mode" >&2
help() {
echo "usage: $SELF <args>
help() {
echo "usage: $SELF <args>
- run <repo>
- <command> Use this repository
+ run <repo> \\
+ <command> Use this repository
- init Initialize a new repository
- clone <remote>
- [<repo>] Clone from an existing repository
-
- exit Exit vcsh mode" >&2
+ init <repo> Initialize a new repository
+ clone <remote> \\
+ [<repo>] Clone from an existing repository" >&2
echo "$SELF: fatal: $GIT_DIR exists" &&
return 21
export GIT_WORK_TREE="$HOME"
echo "$SELF: fatal: $GIT_DIR exists" &&
return 21
export GIT_WORK_TREE="$HOME"
- mkdir -p $GIT_WORK_TREE
- cd $GIT_WORK_TREE ||
+ mkdir -p "$GIT_WORK_TREE"
+ cd "$GIT_WORK_TREE" ||
(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
exit 20) || exit 20
(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
exit 20) || exit 20
- git config core.worktree $GIT_WORK_TREE
+ git config core.worktree "$GIT_WORK_TREE"
elif [ "$1" = 'list' ]; then
verbose "list begin"
elif [ "$1" = 'list' ]; then
verbose "list begin"
- for i in $VCSH_BASE /*.git; do
- echo $(basename $i .git)
+ for i in "$VCSH_BASE" /*.git; do
+ echo $(basename "$i" .git)
done
verbose "list end"
exit 0
elif [ "$1" = 'run' ]; then
verbose "run begin"
done
verbose "list end"
exit 0
elif [ "$1" = 'run' ]; then
verbose "run begin"
verbose "clone begin"
GIT_REMOTE="$2"
REPO_NAME="$3"
verbose "clone begin"
GIT_REMOTE="$2"
REPO_NAME="$3"
- [ -z "$REPO_NAME" ] && REPO_NAME=$(basename $GIT_REMOTE .git)
+ [ -z "$REPO_NAME" ] && REPO_NAME=$(basename "$GIT_REMOTE" .git)
export REPO_NAME
export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
init
export REPO_NAME
export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
init
- git remote add origin $GIT_REMOTE
+ git remote add origin "$GIT_REMOTE"
git config branch.master.remote origin
git config branch.master.merge refs/heads/master
git fetch
git config branch.master.remote origin
git config branch.master.merge refs/heads/master
git fetch
done
[ "$VCSH_CONFLICT" = '1' ] &&
echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
done
[ "$VCSH_CONFLICT" = '1' ] &&
echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
+ echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
exit 3
git merge origin/master
# vcsh use $REPO_NAME
exit 3
git merge origin/master
# vcsh use $REPO_NAME
elif [ "$1" = 'init' ]; then
verbose "init begin"
elif [ "$1" = 'init' ]; then
verbose "init begin"
+ [ -z $2 ] && help && return 0
export REPO_NAME="$2"
export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
init
export REPO_NAME="$2"
export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
init
-elif [ "$1" = 'exit' ]; then
- verbose "exit begin"
- if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
- unset VCSH_NO_IGNORE_EOF
- setopt NO_IGNORE_EOF
- fi
- leave
- [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
- verbose "exit end"
- exit 0
+# elif [ "$1" = 'exit' ]; then
+# verbose "exit begin"
+# if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
+# unset VCSH_NO_IGNORE_EOF
+# setopt NO_IGNORE_EOF
+# fi
+# leave
+# [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+# verbose "exit end"
+# exit 0
else
verbose "defaulting to calling help()"
else
verbose "defaulting to calling help()"